VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsAnalogInput"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------------------------------------------------------------
' Module    : clsAnalogInput
' DateTime  : 5/12/2006 08:22
' Author    : ED
' Purpose   : I don't think this class is used anymore.  Maybe it was for testing?
'---------------------------------------------------------------------------------------

Option Explicit


Private mintChannel As Integer
Private mblnDifferential As Boolean
Private mintGain As Integer
Private mblnUnipolar As Boolean
Private mdblVMin As Double
Private mdblVMax As Double
Private mobjParent As clsMainDAC


Public Property Get Channel() As Integer
    Channel = mintChannel
End Property

Public Property Let Channel(Value As Integer)
    mintChannel = Value
End Property

Public Property Get Differential() As Boolean
    Differential = mblnDifferential
End Property

Public Property Let Differential(Value As Boolean)
    mblnDifferential = Value
End Property

Public Property Get Gain() As Integer
    Gain = mintGain
End Property

Public Property Let Gain(Value As Integer)
    mintGain = Value

    Select Case mintGain
        Case 1, 2, 4, 5, 8, 10, 100, 1000
            mdblVMin = mobjParent.DAC_Device.MinVolt / mintGain
            mdblVMax = mobjParent.DAC_Device.MaxVolt / mintGain

        Case Else
            mdblVMin = mobjParent.DAC_Device.MinVolt
            mdblVMax = mobjParent.DAC_Device.MaxVolt
    End Select
End Property

Public Property Get Unipolar() As Boolean
    Unipolar = mblnUnipolar
End Property

Public Property Let Unipolar(Value As Boolean)
    mblnUnipolar = Value
End Property

Public Property Let Parent(objParent As clsMainDAC)
    Set mobjParent = objParent
End Property


Public Function AnalogInputBits() As Long
    Dim lngRetVal As Long
    Dim udtAninStruct As di_anin_struct


    If mobjParent.IsOpen Then
        ' Fill the data structure
        udtAninStruct.chan = mintChannel
        udtAninStruct.diff = IIf(mblnDifferential, 1, 0)

        Select Case mintGain
            Case 1
                udtAninStruct.Gain = 0

            Case 2
                udtAninStruct.Gain = 1

            Case 4, 5, 100
                udtAninStruct.Gain = 2

            Case 8, 10, 1000
                udtAninStruct.Gain = 3
        End Select

        lngRetVal = di_anin(udtAninStruct)

        AnalogInputBits = Int(lngRetVal / mobjParent.DAC_Device.AnalogInDivider) * mobjParent.DAC_Device.AnalogInDivider
    End If
End Function

Public Function AnalogInputVolts() As Double
    Dim lngRetVal As Long
    Dim dblInputVolts As Double
    Dim udtAninStruct As di_anin_struct


    If mobjParent.IsOpen Then
        ' Fill the data structure
        udtAninStruct.chan = mintChannel
        udtAninStruct.diff = IIf(mblnDifferential, 1, 0)

        Select Case mintGain
            Case 1
                udtAninStruct.Gain = 0
            Case 2
                udtAninStruct.Gain = 1
            Case 4, 5, 100
                udtAninStruct.Gain = 2
            Case 8, 10, 1000
                udtAninStruct.Gain = 3
        End Select

        lngRetVal = di_anin(udtAninStruct)

        lngRetVal = Int(lngRetVal / mobjParent.DAC_Device.AnalogInDivider) * mobjParent.DAC_Device.AnalogInDivider
        dblInputVolts = lngRetVal * (mdblVMax - mdblVMin) / TWO_POWER_16 + (mdblVMax + mdblVMin) / 2

        AnalogInputVolts = dblInputVolts
    End If
End Function

Public Sub ReleaseParent()
    Set mobjParent = Nothing
End Sub

Private Sub Class_Initialize()
    mintChannel = 0
    mblnDifferential = False
    mintGain = 1
    mblnUnipolar = False

    Set mobjParent = Nothing

    DACAddReferenceCount "clsAnalogInput"
End Sub

Private Sub Class_Terminate()
    DACRemoveReferenceCount "clsAnalogInput"
End Sub
