VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDevice"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'---------------------------------------------------------------------------------------
' Module    : clsDevice
' DateTime  : 5/12/2006 06:44
' Author    : ED
' Purpose   : Stores some default device settings depending on DI model #.
'---------------------------------------------------------------------------------------

Option Explicit

Private mudtProps As DeviceProperties


Public Property Get DeviceID() As Integer
    DeviceID = mudtProps.DeviceID
End Property

Public Property Let DeviceID(Value As Integer)
    Select Case Value
        Case DeviceTypes.DI200
            mudtProps.DeviceID = DI200
            mudtProps.AnalogInDivider = 4           ' 2 bits
            mudtProps.AnalogOutMultiplier = 8       ' 4 bits
            mudtProps.DigitalInDivider = 128        ' 8 bits
            mudtProps.DigitalOutMultiplier = 128    ' 8 bits
            mudtProps.MinVolt = -10
            mudtProps.MaxVolt = 10
            mudtProps.AnalogOutMinBitValue = &H8000         ' Value (in Hex)    Range=0 (Bipolar)   Range=1 (Unipolar)
            mudtProps.AnalogOutZeroBitValue = 0             '---------------------------------------------------------
            mudtProps.AnalogOutMaxBitValue = &H7FF0         '   8000                -10                 0
            mudtProps.AnalogOutMinVoltBipolar = -10         '   0000                  0                 5.00
            mudtProps.AnalogOutZeroVoltBipolar = 0          '   7FF0                +9.9951             +9.9976
            mudtProps.AnalogOutMaxVoltBipolar = 9.9951
            mudtProps.AnalogOutMinVoltUnipolar = 0
            mudtProps.AnalogOutZeroVoltUnipolar = 5
            mudtProps.AnalogOutMaxVoltUnipolar = 9.9976
            mudtProps.ClockFrequency = 16000000
            mudtProps.MinSingleBuffer = 8182
            mudtProps.MinInputBuffer = 4091
            mudtProps.MinOutputBuffer = 4091
            mudtProps.ReferenceGain = 8             ' Max Gain = 8
            mudtProps.Range = 0                     ' 0=Bipolar, 1=Unipolar
            mudtProps.DACPort = 0                   ' 0=DAC1, 1=DAC2
            mudtProps.MinBurstRateCount = 200       ' 200   @ 16MHz = 80KHz
            mudtProps.MaxBurstRateCount = 32767     ' 32767 @ 16MHz = 488.2 Hz

        Case DeviceTypes.DI400
            mudtProps.DeviceID = DI400
            mudtProps.AnalogInDivider = 4           ' 2 bits
            'mudtProps.AnalogInDivider = 1           ' 0 bits        Testing for full 16 bit range... 01/24/02 Office
            mudtProps.AnalogOutMultiplier = 8       ' 4 bits
            mudtProps.DigitalInDivider = 128        ' 8 bits
            mudtProps.DigitalOutMultiplier = 128    ' 8 bits
            mudtProps.MinVolt = -10
            mudtProps.MaxVolt = 10
            mudtProps.AnalogOutMinBitValue = &H8000         ' Value (in Hex)    Range=0 (Bipolar)   Range=1 (Unipolar)
            mudtProps.AnalogOutZeroBitValue = 0             '---------------------------------------------------------
            mudtProps.AnalogOutMaxBitValue = &H7FF0         '   8000                -10                 N/A
            'mudtProps.AnalogOutMaxBitValue = &H7FFF         '   8000                -10                 N/A
            mudtProps.AnalogOutMinVoltBipolar = -10         '   0000                  0                 N/A
            mudtProps.AnalogOutZeroVoltBipolar = 0          '   7FF0                +9.9976             N/A
            mudtProps.AnalogOutMaxVoltBipolar = 9.9976
            mudtProps.AnalogOutMinVoltUnipolar = 0
            mudtProps.AnalogOutZeroVoltUnipolar = 0
            mudtProps.AnalogOutMaxVoltUnipolar = 0
            mudtProps.ClockFrequency = 16000000
            mudtProps.MinSingleBuffer = 15000
            mudtProps.MinInputBuffer = 8192
            mudtProps.MinOutputBuffer = 6144
            mudtProps.ReferenceGain = 4             ' Max Gain = 8
            mudtProps.Range = 0                     ' Polarity 0=Bipolar, 1 = Unipolar
            mudtProps.DACPort = 0                   ' 0=DAC1, 1=DAC2
            mudtProps.MinBurstRateCount = 200       ' 200   @ 16MHz = 80KHz
            mudtProps.MaxBurstRateCount = 32767     ' 32767 @ 16MHz = 488.2 Hz

        Case DeviceTypes.DI500
            mudtProps.DeviceID = DI500
            mudtProps.AnalogInDivider = 4           ' 2 bits
            mudtProps.AnalogOutMultiplier = 8       ' 4 bits
            mudtProps.DigitalInDivider = 128        ' 8 bits
            mudtProps.DigitalOutMultiplier = 128    ' 8 bits
            mudtProps.MinVolt = -10
            mudtProps.MaxVolt = 10
            mudtProps.AnalogOutMinBitValue = &H8000         ' Value (in Hex)    Range=0 (Bipolar)   Range=1 (Unipolar)
            mudtProps.AnalogOutZeroBitValue = 0             '---------------------------------------------------------
            mudtProps.AnalogOutMaxBitValue = &H7FF0         '   8000                -10                 N/A
            mudtProps.AnalogOutMinVoltBipolar = -10         '   0000                  0                 N/A
            mudtProps.AnalogOutZeroVoltBipolar = 0          '   7FF0                +9.9976             N/A
            mudtProps.AnalogOutMaxVoltBipolar = 9.9976
            mudtProps.AnalogOutMinVoltUnipolar = 0
            mudtProps.AnalogOutZeroVoltUnipolar = 0
            mudtProps.AnalogOutMaxVoltUnipolar = 0
            mudtProps.ClockFrequency = 16000000
            mudtProps.MinSingleBuffer = 7500
            mudtProps.MinInputBuffer = 4096
            mudtProps.MinOutputBuffer = 3072
            mudtProps.ReferenceGain = 8             ' Max Gain = 8
            mudtProps.Range = 0                     ' Polarity 0=Bipolar, 1 = Unipolar
            mudtProps.DACPort = 0 '1                   ' 0=DAC1, 1=DAC2
            mudtProps.MinBurstRateCount = 64        ' 64    @ 16MHz = 250KHz
            mudtProps.MaxBurstRateCount = 32767     ' 32767 @ 16MHz = 488.2 Hz

        Case DeviceTypes.DI720
            mudtProps.DeviceID = DI720
            'mudtProps.AnalogInDivider = 4           ' 2 bits        14 bits or 16 bits ????
            mudtProps.AnalogInDivider = 1           ' 2 bits        14 bits or 16 bits ???? Testing for full 16 bits...
            mudtProps.AnalogOutMultiplier = 8       ' 4 bits
            mudtProps.DigitalInDivider = 256        ' 8 bits
            mudtProps.DigitalOutMultiplier = 128    ' 8 bits
            mudtProps.MinVolt = -10
            mudtProps.MaxVolt = 10
            mudtProps.AnalogOutMinBitValue = &H8000         ' Value (in Hex)    Range=0 (Bipolar)   Range=1 (Unipolar)
            mudtProps.AnalogOutZeroBitValue = 0             '---------------------------------------------------------
            mudtProps.AnalogOutMaxBitValue = &H7FFF         '   8000                -10                 N/A
            'mudtProps.AnalogOutMaxBitValue = &H7FF0         '   8000                -10                 N/A
            mudtProps.AnalogOutMinVoltBipolar = -10         '   0000                  0                 N/A
            mudtProps.AnalogOutZeroVoltBipolar = 0          '   7FF0                +9.9976             N/A
            mudtProps.AnalogOutMaxVoltBipolar = 10
            'mudtProps.AnalogOutMaxVoltBipolar = 9.9976
            mudtProps.AnalogOutMinVoltUnipolar = 0
            mudtProps.AnalogOutZeroVoltUnipolar = 0
            mudtProps.AnalogOutMaxVoltUnipolar = 0
            mudtProps.ClockFrequency = 16000000
            mudtProps.MinSingleBuffer = 7500
            mudtProps.MinInputBuffer = 4096
            mudtProps.MinOutputBuffer = 3072
            mudtProps.ReferenceGain = 10             ' Max Gain = 10
            mudtProps.Range = 0                     ' Polarity 0=Bipolar, 1 = Unipolar
            mudtProps.DACPort = 0 '1                   ' 0=DAC1, 1=DAC2
            mudtProps.MinBurstRateCount = 64        ' 64    @ 16MHz = 250KHz
            mudtProps.MaxBurstRateCount = 32767     ' 32767 @ 16MHz = 488.2 Hz

        Case Else
            ' Ignore the settings
            mudtProps.DeviceID = GENERIC_DEVICE
            mudtProps.AnalogInDivider = 1           ' 0 bits
            mudtProps.AnalogOutMultiplier = 1       ' 0 bits
            mudtProps.DigitalInDivider = 1          ' 0 bits
            mudtProps.DigitalOutMultiplier = 1      ' 0 bits
            mudtProps.MinVolt = -10
            mudtProps.MaxVolt = 10
            mudtProps.AnalogOutMinBitValue = &H8000         ' Value (in Hex)    Range=0 (Bipolar)   Range=1 (Unipolar)
            mudtProps.AnalogOutZeroBitValue = 0             '---------------------------------------------------------
            mudtProps.AnalogOutMaxBitValue = &H7FF0         '   8000                -10                 N/A
            mudtProps.AnalogOutMinVoltBipolar = -10         '   0000                  0                 N/A
            mudtProps.AnalogOutZeroVoltBipolar = 0          '   7FF0                 10                 N/A
            mudtProps.AnalogOutMaxVoltBipolar = 10
            mudtProps.AnalogOutMinVoltUnipolar = 0
            mudtProps.AnalogOutZeroVoltUnipolar = 0
            mudtProps.AnalogOutMaxVoltUnipolar = 0
            mudtProps.ClockFrequency = 16000000
            mudtProps.MinSingleBuffer = 8182
            mudtProps.MinInputBuffer = 4091
            mudtProps.MinOutputBuffer = 4091
            mudtProps.ReferenceGain = 1             ' Max Gain = 1
            mudtProps.Range = 0                     ' Polarity 0=Bipolar, 1 = Unipolar
            mudtProps.DACPort = 0                   ' 0=DAC1, 1=DAC2
            mudtProps.MinBurstRateCount = 200       ' 64    @ 16MHz = 250KHz
            mudtProps.MaxBurstRateCount = 32767     ' 32767 @ 16MHz = 488.2 Hz
    End Select
End Property

Public Property Get AnalogInDivider() As Integer
    AnalogInDivider = mudtProps.AnalogInDivider
End Property

Public Property Get AnalogOutMultiplier() As Integer
    AnalogOutMultiplier = mudtProps.AnalogOutMultiplier
End Property

Public Property Get DigitalInDivider() As Integer
    DigitalInDivider = mudtProps.DigitalInDivider
End Property

Public Property Get DigitalOutMultiplier() As Integer
    DigitalOutMultiplier = mudtProps.DigitalOutMultiplier
End Property

Public Property Get MinVolt() As Double
    MinVolt = mudtProps.MinVolt
End Property

Public Property Get MaxVolt() As Double
    MaxVolt = mudtProps.MaxVolt
End Property

Public Property Get MinSingleBufferSize() As Long
    MinSingleBufferSize = mudtProps.MinSingleBuffer
End Property

Public Property Get MinInputBufferSize() As Long
    MinInputBufferSize = mudtProps.MinInputBuffer
End Property

Public Property Get MinOutputBufferSize() As Long
    MinOutputBufferSize = mudtProps.MinOutputBuffer
End Property

Public Property Get ClockFrequency() As Long
    ClockFrequency = mudtProps.ClockFrequency
End Property

Public Property Get ReferenceGain() As Integer
    ReferenceGain = mudtProps.ReferenceGain
End Property

Public Property Get Range() As Integer
    Range = mudtProps.Range
End Property

Public Property Get DACPort() As Integer
    DACPort = mudtProps.DACPort
End Property

Public Property Get MinBurstRateCount() As Integer
    MinBurstRateCount = mudtProps.MinBurstRateCount
End Property

Public Property Get MaxBurstRateCount() As Integer
    MaxBurstRateCount = mudtProps.MaxBurstRateCount
End Property


Public Sub ResetReferenceGainToMax()
    mudtProps.ReferenceGain = 10
End Sub

Public Function IncreaseReferenceGain() As Boolean
    Select Case mudtProps.ReferenceGain
        Case 1
            mudtProps.ReferenceGain = 2
            IncreaseReferenceGain = True

        Case 2
            mudtProps.ReferenceGain = 5
            IncreaseReferenceGain = True

        Case 4
            mudtProps.ReferenceGain = 8
            IncreaseReferenceGain = True

        Case 5
            mudtProps.ReferenceGain = 10
            IncreaseReferenceGain = True

        Case Else
            IncreaseReferenceGain = False
    End Select
End Function

Public Function ReduceReferenceGain() As Boolean
    Select Case mudtProps.ReferenceGain
        Case 10
            mudtProps.ReferenceGain = 5
            ReduceReferenceGain = True

        Case 8
            mudtProps.ReferenceGain = 4
            ReduceReferenceGain = True

        Case 4, 5
            mudtProps.ReferenceGain = 2
            ReduceReferenceGain = True

        Case 2
            mudtProps.ReferenceGain = 1
            ReduceReferenceGain = True

        Case Else
            ReduceReferenceGain = False
    End Select
End Function

Public Function ConvertAnalogOutBitsToVolts(Value As Integer, Range As Integer) As Double
    Dim dblOutVolts As Double


    ' This function converts a bit value into a the corresponding output voltage at the analog out port.
    If Range = 0 Then   ' Bipolar
        If Value >= mudtProps.AnalogOutMinBitValue And Value < mudtProps.AnalogOutZeroBitValue Then
            dblOutVolts = ((mudtProps.AnalogOutMinVoltBipolar - mudtProps.AnalogOutZeroVoltBipolar) / (mudtProps.AnalogOutMinBitValue - mudtProps.AnalogOutZeroBitValue)) * Value
        ElseIf Value > mudtProps.AnalogOutZeroBitValue Then
            dblOutVolts = ((mudtProps.AnalogOutMaxVoltBipolar - mudtProps.AnalogOutZeroVoltBipolar) / (mudtProps.AnalogOutMaxBitValue - mudtProps.AnalogOutZeroBitValue)) * Value
        Else
            dblOutVolts = mudtProps.AnalogOutZeroVoltBipolar
        End If

    Else    ' Range = 1 Unipolar
        If Value > mudtProps.AnalogOutMinBitValue And Value < mudtProps.AnalogOutZeroBitValue Then
            dblOutVolts = ((mudtProps.AnalogOutMinVoltUnipolar - mudtProps.AnalogOutZeroVoltUnipolar) / (mudtProps.AnalogOutMinBitValue - mudtProps.AnalogOutZeroBitValue)) * Value
        ElseIf Value > mudtProps.AnalogOutZeroBitValue Then
            dblOutVolts = ((mudtProps.AnalogOutMaxVoltUnipolar - mudtProps.AnalogOutZeroVoltUnipolar) / (mudtProps.AnalogOutMaxBitValue - mudtProps.AnalogOutZeroBitValue)) * Value
        Else
            dblOutVolts = mudtProps.AnalogOutZeroVoltUnipolar
        End If
    End If

    ConvertAnalogOutBitsToVolts = dblOutVolts
End Function

Public Function ConvertAnalogOutVoltsToBits(Value As Double, Range As Integer) As Double
    Dim lngOutBits As Long


    ' This function converts a bit value into a the corresponding output voltage at the analog out port.
    If Range = 0 Then   ' Bipolar
        If Value > mudtProps.AnalogOutMinVoltBipolar And Value < mudtProps.AnalogOutZeroVoltBipolar Then
            lngOutBits = ((mudtProps.AnalogOutMinBitValue - mudtProps.AnalogOutZeroBitValue) / (mudtProps.AnalogOutMinVoltBipolar - mudtProps.AnalogOutZeroVoltBipolar)) * Value
        ElseIf Value > mudtProps.AnalogOutZeroBitValue Then
            lngOutBits = ((mudtProps.AnalogOutMaxBitValue - mudtProps.AnalogOutZeroBitValue) / (mudtProps.AnalogOutMaxVoltBipolar - mudtProps.AnalogOutZeroVoltBipolar)) * Value
        Else
            lngOutBits = mudtProps.AnalogOutZeroVoltBipolar
        End If

    Else    ' Range = 1 Unipolar
        If Value > mudtProps.AnalogOutMinVoltUnipolar And Value < mudtProps.AnalogOutZeroVoltUnipolar Then
            lngOutBits = ((mudtProps.AnalogOutMinBitValue - mudtProps.AnalogOutZeroBitValue) / (mudtProps.AnalogOutMinVoltUnipolar - mudtProps.AnalogOutZeroVoltUnipolar)) * Value
        ElseIf Value > mudtProps.AnalogOutZeroBitValue Then
            lngOutBits = ((mudtProps.AnalogOutMaxBitValue - mudtProps.AnalogOutZeroBitValue) / (mudtProps.AnalogOutMaxVoltUnipolar - mudtProps.AnalogOutZeroVoltUnipolar)) * Value
        Else
            lngOutBits = mudtProps.AnalogOutZeroVoltUnipolar
        End If
    End If

    ConvertAnalogOutVoltsToBits = lngOutBits
End Function

Private Sub Class_Initialize()
    DeviceID = DeviceTypes.GENERIC_DEVICE
    
    DACAddReferenceCount "clsDevice"
End Sub

Private Sub Class_Terminate()
    DACRemoveReferenceCount "clsDevice"
End Sub
