VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPulse"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'*************************************************************************************
' Class:        clsPulse
'
' Description:  This class represents a Pulse
'
' Used by:
'
' History:      09/07/2001      Gaizka      Created this class
'
'*************************************************************************************

Option Explicit


Private mudtProps As PulseSetup         ' Pulse settings struct


Public Property Get Initialized() As Boolean
    Initialized = mudtProps.Initialized
End Property

Public Property Get Filename() As String
    Filename = mudtProps.Filename
End Property

Public Property Let Filename(Value As String)
    mudtProps.Filename = Value
End Property

Public Property Get InterPulseInterval() As Long
    InterPulseInterval = mudtProps.InterPulseInterval
End Property

Public Property Let InterPulseInterval(Value As Long)
    mudtProps.InterPulseInterval = Value
    Call TestInitialized
End Property

Public Property Get SubInterval() As Long
    SubInterval = mudtProps.SubInterval
End Property

Public Property Let SubInterval(Value As Long)
    mudtProps.SubInterval = Value
    Call TestInitialized
End Property

Public Property Get Duration() As Long
    Duration = mudtProps.Duration
End Property

Public Property Let Duration(Value As Long)
    mudtProps.Duration = Value
    Call TestInitialized
End Property

Public Property Get InterStepInterval() As Long
    InterStepInterval = mudtProps.InterStepInterval
End Property

Public Property Let InterStepInterval(Value As Long)
    mudtProps.InterStepInterval = Value
    Call TestInitialized
End Property

Public Property Get NumberOfSteps() As Integer
    NumberOfSteps = mudtProps.NumberOfSteps
End Property

Public Property Let NumberOfSteps(Value As Integer)
    mudtProps.NumberOfSteps = Value
    Call TestInitialized
End Property

Public Property Get InitialVoltageCurrent() As Double
    InitialVoltageCurrent = mudtProps.InitialVoltageCurrent
End Property

Public Property Let InitialVoltageCurrent(Value As Double)
    mudtProps.InitialVoltageCurrent = Value
End Property

Public Property Get StepChange() As Double
    StepChange = mudtProps.StepChange
End Property

Public Property Let StepChange(Value As Double)
    mudtProps.StepChange = Value
    Call TestInitialized
End Property

Public Property Get PeriodSlow() As Long
    PeriodSlow = mudtProps.PeriodSlow
End Property

Public Property Let PeriodSlow(ByVal Value As Long)
    mudtProps.PeriodSlow = Value
    Call TestInitialized
End Property

Public Property Get PeriodMedium() As Long
    PeriodMedium = mudtProps.PeriodMedium
End Property

Public Property Let PeriodMedium(ByVal Value As Long)
    mudtProps.PeriodMedium = Value
    Call TestInitialized
End Property

Public Property Get PeriodFast() As Long
    PeriodFast = mudtProps.PeriodFast
End Property

Public Property Let PeriodFast(ByVal Value As Long)
    mudtProps.PeriodFast = Value
    Call TestInitialized
End Property

Public Property Get ClampMode() As Integer
    ClampMode = mudtProps.ClampMode
End Property

Public Property Let ClampMode(ByVal Value As Integer)
    mudtProps.ClampMode = Value
End Property

Public Property Get VoltageGain() As Integer
    VoltageGain = mudtProps.VoltageGain
End Property

Public Property Let VoltageGain(ByVal Value As Integer)
    mudtProps.VoltageGain = Value
End Property

Public Property Get CurrentGain() As Integer
    CurrentGain = mudtProps.CurrentGain
End Property

Public Property Let CurrentGain(ByVal Value As Integer)
    mudtProps.CurrentGain = Value
End Property

Public Property Get VoltageAutoGain() As Boolean
    VoltageAutoGain = mudtProps.VoltageAutoGain
End Property

Public Property Let VoltageAutoGain(ByVal Value As Boolean)
    mudtProps.VoltageAutoGain = Value
End Property

Public Property Get CurrentAutoGain() As Boolean
    CurrentAutoGain = mudtProps.CurrentAutoGain
End Property

Public Property Let CurrentAutoGain(ByVal Value As Boolean)
    mudtProps.CurrentAutoGain = Value
End Property


' Load pulse settings from registry
Public Function LoadRegistrySettings()
    Dim objRegKey As clsRegistry


    Set objRegKey = New clsRegistry

    mudtProps.Duration = val(objRegKey.GetSetting("Pulse Setup", "Duration", "100"))
    mudtProps.ClampMode = val(objRegKey.GetSetting("Pulse Setup", "Clamp Mode", Format(ClampModeType.OpenCircuit, "0")))
    mudtProps.Filename = objRegKey.GetSetting("Pulse Setup", "Filename", gobjAppSettings.DataPath & "\Default.PUL")
    mudtProps.InitialVoltageCurrent = val(objRegKey.GetSetting("Pulse Setup", "DC Clamp Level", "0"))
    mudtProps.InterPulseInterval = val(objRegKey.GetSetting("Pulse Setup", "Inter Pulse Interval", "100"))
    mudtProps.InterStepInterval = val(objRegKey.GetSetting("Pulse Setup", "Inter Step Interval", "100"))
    mudtProps.NumberOfSteps = val(objRegKey.GetSetting("Pulse Setup", "Number of Steps", "1"))
    mudtProps.PeriodFast = val(objRegKey.GetSetting("Pulse Setup", "Period Fast", "2"))
    mudtProps.PeriodMedium = val(objRegKey.GetSetting("Pulse Setup", "Period Medium", "10"))
    mudtProps.PeriodSlow = val(objRegKey.GetSetting("Pulse Setup", "Period Slow", "20"))
    mudtProps.StepChange = val(objRegKey.GetSetting("Pulse Setup", "Step Change", "10"))
    mudtProps.SubInterval = val(objRegKey.GetSetting("Pulse Setup", "Sub Interval", "100"))

    mudtProps.VoltageGain = val(objRegKey.GetSetting("Pulse Setup", "Voltage Gain", "1"))
    mudtProps.CurrentGain = val(objRegKey.GetSetting("Pulse Setup", "Current Gain", "1"))
    mudtProps.VoltageAutoGain = IIf(val(objRegKey.GetSetting("Pulse Setup", "Voltage Auto Gain", "0")) = 1, True, False)
    mudtProps.CurrentAutoGain = IIf(val(objRegKey.GetSetting("Pulse Setup", "Current Auto Gain", "0")) = 1, True, False)

    Set objRegKey = Nothing

    Call TestInitialized
End Function

' Save pulse settings to registry
Public Function SaveRegistrySettings()
    Dim objRegKey As clsRegistry


    Set objRegKey = New clsRegistry
    
    Call objRegKey.SaveSetting("Pulse Setup", "Duration", mudtProps.Duration)
    Call objRegKey.SaveSetting("Pulse Setup", "Clamp Mode", mudtProps.ClampMode)
    Call objRegKey.SaveSetting("Pulse Setup", "Filename", mudtProps.Filename)
    Call objRegKey.SaveSetting("Pulse Setup", "DC Clamp Level", mudtProps.InitialVoltageCurrent)
    Call objRegKey.SaveSetting("Pulse Setup", "Inter Pulse Interval", mudtProps.InterPulseInterval)
    Call objRegKey.SaveSetting("Pulse Setup", "Inter Step Interval", mudtProps.InterStepInterval)
    Call objRegKey.SaveSetting("Pulse Setup", "Number of Steps", mudtProps.NumberOfSteps)
    Call objRegKey.SaveSetting("Pulse Setup", "Period Fast", mudtProps.PeriodFast)
    Call objRegKey.SaveSetting("Pulse Setup", "Period Medium", mudtProps.PeriodMedium)
    Call objRegKey.SaveSetting("Pulse Setup", "Period Slow", mudtProps.PeriodSlow)
    Call objRegKey.SaveSetting("Pulse Setup", "Step Change", mudtProps.StepChange)
    Call objRegKey.SaveSetting("Pulse Setup", "Sub Interval", mudtProps.SubInterval)

    Call objRegKey.SaveSetting("Pulse Setup", "Voltage Gain", mudtProps.VoltageGain)
    Call objRegKey.SaveSetting("Pulse Setup", "Current Gain", mudtProps.CurrentGain)
    Call objRegKey.SaveSetting("Pulse Setup", "Voltage Auto Gain", IIf(mudtProps.VoltageAutoGain, 1, 0))
    Call objRegKey.SaveSetting("Pulse Setup", "Current Auto Gain", IIf(mudtProps.CurrentAutoGain, 1, 0))

    Set objRegKey = Nothing
End Function

' Set up test data values
Public Sub InitializeTestData(ByVal lngNumSamples As Long)
    mudtProps.InterPulseInterval = 1000         ' in ms
    mudtProps.SubInterval = 100                 ' in ms
    mudtProps.Duration = 400                    ' in ms
    mudtProps.NumberOfSteps = lngNumSamples
    mudtProps.InitialVoltageCurrent = 10        ' in mV / uA
    mudtProps.StepChange = 5
    mudtProps.PeriodSlow = 60                   ' in s
    mudtProps.PeriodMedium = 10                 ' in s
    mudtProps.PeriodFast = 2                    ' in s
    mudtProps.Initialized = True
End Sub

' Return the total duration (in milliseconds) of the pulse
Public Function TotalDuration() As Long
    Dim lngTotDur As Long

    lngTotDur = mudtProps.InterPulseInterval * mudtProps.NumberOfSteps

    TotalDuration = lngTotDur
End Function

' Copy passed instance values to current instance
Public Sub Copy(SourcePulse As clsPulse)
    mudtProps.ClampMode = SourcePulse.ClampMode
    mudtProps.Duration = SourcePulse.Duration
    mudtProps.Filename = SourcePulse.Filename
    mudtProps.Initialized = SourcePulse.Initialized
    mudtProps.InitialVoltageCurrent = SourcePulse.InitialVoltageCurrent
    mudtProps.InterPulseInterval = SourcePulse.InterPulseInterval
    mudtProps.InterStepInterval = SourcePulse.InterStepInterval
    mudtProps.NumberOfSteps = SourcePulse.NumberOfSteps
    mudtProps.PeriodFast = SourcePulse.PeriodFast
    mudtProps.PeriodMedium = SourcePulse.PeriodMedium
    mudtProps.PeriodSlow = SourcePulse.PeriodSlow
    mudtProps.StepChange = SourcePulse.StepChange
    mudtProps.SubInterval = SourcePulse.SubInterval

    mudtProps.VoltageGain = SourcePulse.VoltageGain
    mudtProps.CurrentGain = SourcePulse.CurrentGain
    mudtProps.VoltageAutoGain = SourcePulse.VoltageAutoGain
    mudtProps.CurrentAutoGain = SourcePulse.CurrentAutoGain
End Sub

' Test values
Private Sub TestInitialized()
    If mudtProps.Duration <= 0 Then
        mudtProps.Initialized = False
        Exit Sub
    End If
    If mudtProps.InterPulseInterval <= 0 Then
        mudtProps.Initialized = False
        Exit Sub
    End If
    If mudtProps.NumberOfSteps <= 0 Then
        mudtProps.Initialized = False
        Exit Sub
    End If
    If mudtProps.PeriodFast <= 0 Then
        mudtProps.Initialized = False
        Exit Sub
    End If
    If mudtProps.PeriodMedium <= 0 Then
        mudtProps.Initialized = False
        Exit Sub
    End If
    If mudtProps.PeriodSlow <= 0 Then
        mudtProps.Initialized = False
        Exit Sub
    End If
    If mudtProps.SubInterval <= 0 Then
        mudtProps.Initialized = False
        Exit Sub
    End If

    mudtProps.Initialized = True
End Sub

' Class constructor
Private Sub Class_Initialize()
    gRefCnt.AddObjectInstance "clsPulse"
End Sub

' Class destructor
Private Sub Class_Terminate()
    gRefCnt.RemoveObjectInstance "clsPulse"
End Sub
